using System;
using System.Collections;
using UnityEngine;

namespace CheesyFX
{
    public class OrificeTriggerHandler : MonoBehaviour
    {
        public bool isActive;
        public Orifice orifice;
        // public Collider lastCollider;
        public int numCollisions
        {
            get { return _numCollisions; }
            set
            {
                if (value > 0) _numCollisions = value;
                else
                {
                    _numCollisions = 0;
                    orifice.isPenetrated = false;
                }
            }
        }
        private int _numCollisions;
		
        public void OnTriggerEnter(Collider collider)
        {
            
            if (collider.isTrigger || collider.attachedRigidbody.GetRegionName() == "pelvis")
            {
                return;
            }
            numCollisions++;
            if (!enabled)
            {
                if (orifice.isPenetrated)
                {
                    orifice.isPenetrated = false;
                }
                return;
            }
            if (!orifice.isPenetrated)
            {
                orifice.RegisterCollision(collider);
            }
        }
		
        public void OnTriggerExit(Collider collider)
        {
            if (collider.isTrigger) return;
            numCollisions--;
        }

        private void OnDisable()
        {
            Reset();
        }

        public void Reset()
        {
            orifice.isPenetrated = false;
        }
    }
}